﻿using Ptv.XServer.Controls.Map.Layers.Shapes;
using Ptv.XServer.Controls.Map.Symbols;
using System;
using System.Windows;
using System.Windows.Forms;

namespace SelectionWinForms
{
    public partial class Form1 : Form
    {
        private const string token = "";

        private SelectInteractor selectInteractor;

        public Form1()
        {
            InitializeComponent();

            // initialize base map (for xServer internet)
            formsMap1.XMapUrl = "https://xmap-eu-n-test.cloud.ptvgroup.com/xmap/ws/XMap";
            formsMap1.XMapCredentials = "xtok:" + token;
            formsMap1.XMapStyle = "gravelpit";

            formsMap1.WrappedMap.Loaded += WrappedMap_Loaded;
        }

        private void WrappedMap_Loaded(object sender, RoutedEventArgs e)
        {
            var myLayer = new ShapeLayer("ManySymbols") { LazyUpdate = true };
            this.formsMap1.Layers.Add(myLayer);

            // copied from DemoCenter Selection use case
            var center = new Point(8.4, 49); // KA
            const int radius = 1; // radius in degrees of latitude

            var rand = new Random();
            Func<Point, double, Point> randomCoordinate = (c, r) =>
            {
                var angle = rand.NextDouble() * 2 * Math.PI;
                var distance = r * Math.Sqrt(rand.NextDouble());

                return new Point { X = c.X + distance * Math.Cos(angle), Y = c.Y + distance * Math.Sin(angle) };
            };

            for (var i = 0; i < 50; i++)
            {
                Pin symbol;
                symbol = new Pin();
                symbol.Width = symbol.Height = 20;
                ShapeCanvas.SetLocation(symbol, randomCoordinate(center, radius));
                symbol.ToolTip = i;
                myLayer.Shapes.Add(symbol);
            }

            // set center and zoom level
            this.formsMap1.SetMapLocation(center, 9);

            // get the map view containing the content
            var mapView = Ptv.XServer.Controls.Map.Tools.MapElementExtensions.FindChild<Ptv.XServer.Controls.Map.MapView>(formsMap1.WrappedMap);

            // set selection iterator
            selectInteractor = new SelectInteractor(mapView, myLayer.Shapes);
        }
    }
}